!  8/31/2009 : v_pairing by sum kappa Delta
!  9/12/2009 : v_pairing corrected
program nuc_hfb
 include 'global7'
 integer,parameter :: NORB_MAX=100
 integer :: iNpart
 real :: esp(NORB_MAX),espo(NORB_MAX),fpart
 integer :: lmax,iter
 integer ::   i,j,l,Nbase
 real :: temp,v_pairing,etot
 common/kr/k_r
 call initial()
 call make_v()
 lmax = 4
 N_orb=0
 print*, ''
 print*, 'L     e_sp  * kept for HFB'
 do l=0,lmax
   call uu(l)
   call make_ham(l)
 enddo
 print*, ''
 print*, ' L block size   eigenvalue multiplicity'
 Nbase=0
 do l=0,lmax
  call ham_diag(l,Nbase,esp)
 enddo
 write(41,*) Nbase
 do i = 1, Nbase
   write(41,*) esp(i)
 enddo
 call assign_2bodydata
 iter = 20
 do i=1,iter
   k_rnew=0.0
   dNdl = 0.0
   Npart=0.0
   do l=0,lmax
     if(ham_d(l).gt.0) then
       call make_delta(l,k_r)
       call make_hfb(l)
       call solve_hfb(l)
       call update_kr(l)
     endif
   enddo 
!   k_r=0.1 * k_rnew + 0.9 * k_r
   k_r=k_rnew
   call write_k_r()                 ! on fort.22
 enddo
 print*, '0: Npart, dNdl', Npart, dNdl
 v_pairing=0.0
 esp_tot=0.0
 Npart=0.0
 do l=0,lmax
   if(ham_d(l).gt.0) then
       call make_delta(l,k_r)
       call make_hfb(l)
       call solve_hfb(l)
    call make_delta(l,k_rnew)
!    print*, delta
    call energy(l,temp)
    v_pairing= v_pairing + temp
    print*, temp,v_pairing
   endif
 enddo 
 print*, 'esp_tot, v_pairing, E ', esp_tot, v_pairing, esp_tot-v_pairing
 iNpart=Npart
 fpart=Npart-iNpart
 print*, Npart, iNpart, fpart,Nbase
 espo = esp
 call order(espo,Nbase,NORB_MAX)
 etot= 0.0
 do i = 1, iNpart
    etot= etot + espo(i)
 enddo
 if(fpart.gt.0.0) etot = etot + espo(iNpart+1)*fpart
 print*, 'ehf, ecorr' ,etot, esp_tot-v_pairing-etot 
 call write_k_r()                 ! on fort.22
end  program nuc_hfb
!
subroutine uu(l)
  include 'global7'
!  for eispack diagonalizer
        integer :: ierr
        real (8) ::  aa(D_r,D_r),ww(D_r),z(D_r,D_r)
        real (8) :: fv1(D_r),fv2(D_r),f1
!
      real :: u(D_r),ddd,r
      integer :: l,n,i,node,nmax,iter,j
      aa=0.0
      ddd=h2m/delr**2
      do i=1,N_r
        r=i*delr
        aa(i,i) = l*(l+1)*h2m/r**2 + v_ws(i) +2.5*ddd
        if (i.gt.1) then
            aa(i-1,i) = -ddd*(4./3.)
            aa(i,i-1) = -ddd*(4./3.)
        endif
        if ( i.gt.2) then
            aa(i-2,i) = ddd/12.
           aa(i,i-2) = ddd/12.
        endif
      enddo
      aa(1,1)=aa(1,1)- ddd/12.
   3  continue
      call rs(D_r,N_r,aa,ww,1,z,fv1,fv2,ierr)
12      format(40f10.4)
      do i=1,N_r
        if(ww(i).gt.Emin.and.ww(i).lt.Emax) then
           N_orb= N_orb+1
           eps(N_orb)=ww(i)
           lorb(N_orb)= l
           write(6,15) lorb(N_orb),eps(N_orb)
15 format(i3,f10.5,' *')
           w(N_orb,1:N_r) = z(1:N_r,i)/sqrt(delr)
           f1= sum(w(N_orb,1:N_r)**2*v_ls(1:N_r))*delr
           eps_ls(N_orb)=f1
        elseif (ww(i).lt.0.0) then
           write(6,14) l, ww(i)
14 format(i3,f10.5)
        endif
      enddo
end subroutine
!
subroutine make_v()
  include 'global7'
  integer :: i
  real :: r,temp
  do i=1,D_r
    r=i*delr
    temp=1./(1.+exp((r-radius)/a)) 
    if  (temp.lt.1.0e-6) goto  3
      v_ws(i) = V0*temp 
      v_ls(i)= -2*vso*exp((r-radius)/a)*temp**2/r/a ! may change
  enddo
3 continue
  temp=0.0
end subroutine make_v
!
subroutine check_ls()
  include 'global7'
  integer :: i,l
  real :: s1,f1,e
  do i = 1,N_orb
     s1=sum(w(i,1:N_r)**2)*delr
     f1= sum(w(i,1:N_r)**2*v_ls(1:N_r))*delr
     eps_ls(i)=f1
     l=lorb(i)
     e=eps(i)
     print*, i,s1,f1,e-f1*(l+1)/2.,e+f1*l/2.
  enddo
end subroutine check_ls

! make sub ham of given l = el
subroutine make_ham(el)
  include 'global7'
!
  integer :: i,j,k,el,ix,ixx,k1,k2,iy
  integer :: subdim,m
  real :: rad_sum,szz(4)
  data szz/1.0,-1.0,1.0,-1.0/
  ham_d(el)=0
  subdim = (2*el+1)*4
  ! Part 1:  label orbit with l =el
  ! get the size of this ham
  ! get energy basis of ham 
  ham(el,:,:) = 0.0   
  do i=1,N_orb
    if(lorb(i).eq.el) then
      ! dimension: (2L + 1)* 4 for each (n)
      ! convention: m=l,l-1,l-2....0,1,...l 
      do k= 1,(2*el +1)
        f2orb(el,ham_d(el)+4*(k-1)+1:ham_d(el)+4*(k-1)+4)=i
        do j=1,4
          ham(el,ham_d(el)+4*(k-1)+j,ham_d(el)+4*(k-1)+j) = eps(i)
        enddo
      enddo
      ham_d(el) = ham_d(el) + subdim 
    endif
  enddo

  ! Part 2: construct spin-orbit part of ham
  do i=1,ham_d(el)/subdim
    k1=f2orb(el,subdim*i)
    do j=1,ham_d(el)/subdim
      k2=f2orb(el,subdim*j)
      rad_sum = sum(w(k1 ,1:N_r)*v_ls(1:N_r)*w(k2,1:N_r))*delr  ! use the last index in i,j block
      ! A: same-m part
      do ixx=0,2*el
        m = el - ixx
        do iy=1,4
          ix = ixx*4+iy
          ham(el,subdim*(i-1)+ix,subdim*(j-1)+ix) = &
          ham(el,subdim*(i-1)+ix,subdim*(j-1)+ix) + &
           m*0.5*rad_sum*szz(iy)
        enddo
      enddo
      ! B: m -> m+1 part
      do ixx=1,2*el
        m = el -ixx
        do iy=1,3,2
         ix=ixx*4+iy
        ham(el,subdim*(i-1)+ix-3,subdim*(j-1)+ix ) = &
           sqrt(real(el*(el+1) - m*(m+1))) /2.0 * rad_sum
        ham(el,subdim*(i-1)+ix,subdim*(j-1)+ix-3 ) = &
            ham(el,subdim*(j-1)+ix-3,subdim*(i-1)+ix ) 
        enddo
      enddo        
    enddo
  enddo
end subroutine make_ham
subroutine ham_diag(el,Nbase,esp)
  include 'global7'
!  for eispack diagonalizer
   integer :: ierr,i,el,Nbase
   real (8) ::  aa(D_ham,D_ham),ww(D_ham),z(D_ham,D_ham)
   real (8) :: fv1(D_ham),fv2(D_ham),f1
   real     :: esp(100)
   N_ham=ham_d(el)
  if(ham_d(el).ne.0 ) then
    write(6,14) el, ham_d(el)
14 format(i3,i5)
    aa(1:N_ham,1:N_ham) = ham(el,1:N_ham,1:N_ham)
    call rs(D_ham,N_ham,aa,ww,1,z,fv1,fv2,ierr)
    call multiplicity(N_ham,ww)
    do i=1,N_ham
      esp(i+Nbase)=ww(i)
    enddo
    Nbase=Nbase+N_ham
  endif
12 format(40f10.4)
end subroutine ham_diag
!
subroutine make_delta(el,k_r)
 include 'global7'
 integer,parameter:: alpha=6
 integer :: el,subdim,nc,gi,gj
 integer :: i,j,l,alp,ic,k1,k2,ixx,m
 real :: rad_sum(6),temp
! (S,T) = (0,(11)),(0,(10)),(0,(1-1)),((1,0),0),((11),0), ((1-1),0) 
 subdim=(2*el+1)*4
 delta=0.0
 ! loop over w's 
 do i=1,ham_d(el)/subdim
   k1=f2orb(el,subdim*i)
   do j=1,ham_d(el)/subdim
      k2=f2orb(el,subdim*j)
      rad_sum = 0.0
      do alp=1,6
         rad_sum(alp) = rad_sum(alp) + delr* sum( w(k1,1:N_r)*w(k2,1:N_r)*k_r(alp,1:N_r))
      enddo
       do ixx=0,2*el
         m= el - ixx
         do alp=1,6
           nc = case(alp)
           do ic=1,nc
             gi = subdim*(i-1) + (el-m)*4 + part1(ic,alp) +1 
             gj = subdim*(j-1) + (el+m)*4 + part2(ic,alp) +1
             temp=delta(gi,gj)
             delta(gi,gj) = delta(gi,gj) +  &
                 dd(ic,alp)*((-1.0)**(m))*rad_sum(alp)*vpair(alp) 
!             if(temp.ne.delta(gi,gj)) print*,gi,gj,delta(gi,gj)
           enddo
         enddo
       enddo
   enddo
 enddo  
12 format(10f6.3)
end subroutine make_delta
!
subroutine make_hfb(el)
  include 'global7'
  integer :: el,i1,i2,subdim
  hfb=0.0
  subdim=ham_d(el)
  hfb(1:subdim,1:subdim) = ham(el,1:subdim,1:subdim)
  do i1 = 1,subdim
    hfb(i1,i1) = hfb(i1,i1) - lambda
  enddo
  hfb(subdim+1:2*subdim,subdim+1:2*subdim) = - hfb(1:subdim,1:subdim)
  hfb(1:subdim,subdim+1:2*subdim) = delta(1:subdim,1:subdim)
  hfb(subdim+1:2*subdim,1:subdim) = -delta(1:subdim,1:subdim)
end subroutine make_hfb
!
subroutine solve_hfb(el)
  include 'global7'
  integer,parameter:: alpha=6
!  for eispack diagonalizer
  integer :: ierr
  real (8) :: ww(D_ham2),z(D_ham2,D_ham2)
  real (8) :: fv1(D_ham2),fv2(D_ham2),f1
!
  integer :: el,dim1,dh,subdim,nc
  integer :: i,j,im,alp,ic,gi,gj,k1,k2,i1,i2
  real :: uu(D_ham,D_ham),vv(D_ham,D_ham),vvt(D_ham,D_ham)
  real :: irsquare(1:D_r),temp,rho(D_ham,D_ham)
  irsquare = 0.0
  do i=1,N_r
    irsquare(i) = 1.0 /((i *delr)**2.0)      ! 1/r**2
  enddo
  dim1=2*ham_d(el)
  call rs(D_ham2,dim1,HFB,ww,1,z,fv1,fv2,ierr)
  print*, ''
  print*, 'HFB eigenvalue multiplicities'
  call multiplicity(dim1,ww)
! get kappa
  dh=dim1/2
  uu = 0.0
  vv = 0.0
  vvt = 0.0
  uu(1:dh,1:dh) = z(1:dh,dh+1:2*dh)
  vv(1:dh,1:dh) = z(dh+1:2*dh,dh+1:2*dh)
  vvt=transpose(vv)
  kappa= matmul(uu,vvt)
  rho = matmul(vv,vvt)
  call canonical(ww,vv,uu,dh)
  do i= 1,dh
    do j = 1,dh
      esp_tot = esp_tot + rho(i,j)*ham(el,j,i)
    enddo
  enddo
  print*, 'esp_tot ', esp_tot
  do i = 1,dh
    Npart = Npart + rho(i,i)
  enddo
  print*, 'Npart ',Npart
  do i = 1,dh
12 format(80f6.3)
  enddo 
! check that kappa is antisymmetric
  do i1=1,dh
    do i2=1,i1-1
      temp=kappa(i1,i2)+kappa(i2,i1)
      if(temp**2.gt.1.0e-6) then
         print*, 'kappa not antisymmetric', i1,i2,kappa(i1,i2),kappa(i2,i1)
!         stop
      endif
    enddo
  enddo
end subroutine solve_hfb
!
subroutine update_kr(el)
  include 'global7'
  integer,parameter:: alpha=6
!
  integer :: el,dim1,dh,subdim,nc
  integer :: i,j,im,alp,ic,gi,gj,k1,k2,i1,i2
  real :: uu(D_ham,D_ham),vv(D_ham,D_ham),vvt(D_ham,D_ham)
  real :: irsquare(1:D_r),temp,rho(D_ham,D_ham)
  irsquare = 0.0
  do i=1,N_r
    irsquare(i) = 1.0 /((i *delr)**2.0)      ! 1/r**2
  enddo
  dim1=2*ham_d(el)
  subdim=(2*el+1)*4
 do i=1,ham_d(el)/subdim
   k1=f2orb(el,subdim*i)
   do j=1,ham_d(el)/subdim
      k2=f2orb(el,subdim*j)
      do im=1,(2*el+1) ! m: m(k) = -m(l) 
!        do alp=1,alpha
        do alp=1,6
          nc = case(alp)
          do ic=1,nc
            gi = subdim*(i-1) + (im-1)*4 + part1(ic,alp)+1
            gj = subdim*(j-1) + (2*el+1-im)*4 + part2(ic,alp)+1
            if(gj.gt.gi) then       ! assume kappa is antisymmetric
             k_rnew(alp,1:N_r) = k_rnew(alp,1:N_r) + &
               kappa(gi,gj)* dd(ic,alp)*((-1.0)**(im-1-el))* w(k1,1:N_r)*w(k2,1:N_r)*irsquare(1:N_r)/(4.0*pi)
            endif
          enddo
        enddo       
      enddo
    enddo
  enddo     
end subroutine update_kr
!
subroutine assign_2bodydata
! channels are (S,T) = (0,(11)),(0,(10)),(0,(1-1)),((1,0),0),((11),0), ((1-1),0) 
! spin-isospin labels are (sz,tz) = (u,u),(d,u),(u,d),(d,d)
 include 'global7'
! data vpair/300.,300.,300.,450.,450.,450./
 data case/2,4,2,4,2,2/
 data part1/0,1,0,0, 0,1,2,3, 2,3,0,0, 0,1,2,3, 0,2,0,0, 1,3,0,0/
 data part2/1,0,0,0, 3,2,1,0, 3,2,0,0, 3,2,1,0, 2,0,0,0, 3,1,0,0/
 data dd/1.0,-1.0,0.,0., 0.707,-0.707,0.707,-0.707, 1.0,-1.0,0.,0.,  0.707,0.707,-0.707,-0.707,1.0,-1.0,0.0,0.0, 1.0,-1.0,0.0,0.0/
end subroutine assign_2bodydata
!
subroutine write_k_r()
 include 'global7'
 integer :: i,j
 write(22,13) N_r
13 format(i4)
 do i=1,6
   write(22,12) ( k_rnew(i,j),j=1,N_r)
12 format(100e12.4)
 enddo
end subroutine write_k_r
subroutine read_k_r()
 include 'global7'
 common/kr/k_r
 integer :: i,j
 read(21,*) N_r
 do i=1,6
   read(21,*) ( k_r(i,j),j=1,N_r)
12 format(100e12.4)
 enddo
end subroutine read_k_r
!
subroutine initial()
 include 'global7'
 common/kr/k_r
 real :: kc(6),v01,v10
 integer :: i,ir
 print*, 'Input data'
 read*, N_r
 read*, a
 read*, radius
 read*, V0
 read*, vso
 read*, Emin
 read*, Emax
 read*, lambda
 read*, v01,v10
 do i = 1,3
   vpair(i) = v01
   vpair(i+3) = v10
 enddo
 write(6,13) N_r
13 format(8i4)
 write(6,12) a,radius,V0,vso,Emin,Emax,lambda
12 format(8f10.5)
 read*, kc
 if (kc(1).gt.99.0) then
   call read_k_r()                ! on fort.21
 else
   do i = 1,6
     k_r(i,:) = kc(i)
   enddo
 endif
 ir=radius/delr
 print*, 'ir,k(1:6,ir)'
 write(6,123) ir,(k_r(i,ir),i=1,6)
123 format(i3,6f9.5)
end subroutine initial
!
subroutine multiplicity(ntot,data)
  implicit none
  integer :: i,j,ndif,ntot,num(100)
  real :: val(100),dtemp
  real (8) :: data(1)
  ndif=0
  if(ntot.gt.0) then
  do i=1,ntot
    dtemp= data(i)
    do j= 1,ndif
      if(abs(dtemp-val(j)).lt.0.001) then
        num(j) = num(j) + 1
        go to 7
      endif
    enddo
    ndif=ndif+1
    val(ndif) =dtemp
    num(ndif) = 1
7 continue
  enddo
!  print*, 'multiplicities'
  do i=1,ndif
    write(6,14) num(i),val(i)
14 format('    ',i3,f10.5)
   enddo
   else
     print*, ' '
   endif
end subroutine multiplicity
subroutine energy(el,temp)
 include 'global7'
 real :: temp,t2
 integer :: dim,el,i,j
 dim = ham_d(el)
 temp=0.0
 do i = 1, dim
    do j  = i+1, dim
      temp=temp+kappa(i,j)*delta(i,j)
      if(abs(temp-t2).gt.0.001) then 
!        print*,i,j,kappa(i,j),delta(i,j),temp
        t2=temp   
      endif
    enddo
 enddo
end subroutine energy
!
subroutine canonical(ww,vv,uu,dh)
  include 'global7'
  real (8) :: ww(D_ham2)
  real :: uu(D_ham,D_ham),vv(D_ham,D_ham),uc(D_ham),vc(D_ham),hc(D_ham)
  real :: delc(D_ham),eqp,t1,t2,npar
  integer :: i,dh
  npar=0.0
  do i=1,dh
    eqp=ww(dh+i)
    t1= sum(vv(1:dh,i)**2)
    t2= sum(uu(1:dh,i)**2)
    vc(i)= sqrt(t1)
    uc(i) = sqrt(t2)
    hc(i)=eqp*(t2-t1)
    delc(i) = eqp*2*sqrt(t1*t2)
    npar= npar + (1.-hc(i)/eqp)/2.
    dNdl = dNdl + delc(i)**2/eqp**3/2.
!    write(6,12) t1,t2,hc(i),delc(i),eqp
  enddo
12 format(8f10.5)
end subroutine canonical
!
      subroutine order(D,N,NP)
      real :: D(NP)
      DO 13 I=1,N-1
        K=I
        P=D(I)
        DO 11 J=I+1,N
          IF(D(J).LT.P)THEN
            K=J
            P=D(J)
          ENDIF
11      CONTINUE
        IF(K.NE.I)THEN
          D(K)=D(I)
          D(I)=P
        ENDIF
13    CONTINUE
      RETURN
      end

